/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Dec. 2006

 File          : UART1.c

 Hardware      : Applicable to ADuC703x

 Description   : This code is an example of interrupt driven UART communication					   
		
*********************************************************************/
#include <ADuC7033.h>
void My_IRQ_Function(void);

unsigned char ucSendPacket = 0;
unsigned char ucRead = 0;
unsigned char ucCOMSTA0 = 0;
unsigned char ucCOMIID0 = 0;
unsigned int uiIRQSTA = 0;
char output1[60] = "ADuC7033 Tx Interrupt Demo\n";
unsigned char ucStringCnt = 0;

int main (void){

	IRQ = My_IRQ_Function;
	IRQEN = 0x800;

	GP1CON = 0x011;
  	COMCON0 = 0x80;				// Setting DLAB
	COMDIV0 = 0x02;				// 115200 bps
   	COMDIV1 = 0x00;
   	COMCON0 = 0x07;				// Clearing DLAB
  	COMDIV2 = 0x8B1C;
	COMCON1 = 0x80;
	COMIEN0 = 0x3;				// Enable interrupt on byte received and transmit buffer empty

while (1){
	 	if (ucSendPacket == 1){
				COMTX =0xD;		// CR
				ucStringCnt = 0;
				ucSendPacket = 0;
			}	
	}
}



/********************************************************************/
/*                                                                  */
/*		Interrupt Service Rountine									*/
/*                                                                  */
/********************************************************************/

void My_IRQ_Function(){		
	uiIRQSTA = IRQSTA;
	if ((uiIRQSTA & 0x800) == 0x800){		// Check UART bit
		ucCOMSTA0 = COMSTA0;
		ucCOMIID0 = COMIID0;
	 	if ((ucCOMIID0 & 0x2) == 0x2){		// Transmit buffer empty
			if (ucStringCnt < 60){
				COMTX = output1[ucStringCnt++];
			}
		}
		if ((ucCOMIID0 & 0x4) == 0x4){		// Receive byte
			ucRead = COMRX;
			if (ucRead == 0x55)
			  ucSendPacket = 1;
		}
	}
	return ;
}




